classification
Title: Debug support for native coroutines is broken
Type: enhancement Stage: resolved
Components: Versions: Python 3.7, Python 3.6
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: Nosy List: asvetlov, njs, yselivanov
Priority: normal Keywords: patch

Created on 2018-01-24 15:08 by asvetlov, last changed 2018-01-29 14:22 by miss-islington. This issue is now closed.

Pull Requests
URL Status Linked Edit
PR 5400 merged pablogsal, 2018-01-28 23:00
PR 5402 merged miss-islington, 2018-01-29 00:31
PR 5403 merged pablogsal, 2018-01-29 00:34
PR 5406 merged yselivanov, 2018-01-29 03:23
PR 5411 merged asvetlov, 2018-01-29 06:18
PR 5419 merged miss-islington, 2018-01-29 10:14
PR 5427 merged asvetlov, 2018-01-29 13:40
PR 5428 merged miss-islington, 2018-01-29 14:22
Messages (7)
msg310600 - (view) Author: Andrew Svetlov (asvetlov) * (Python committer) Date: 2018-01-24 15:08
pdb (and other Python debuggers) are built on top of bdb.py module.

The module has a support for stepping to next line in function (next command).

The command checks frame flags and do extra steps if the flags contains CO_GENERATOR.

But CO_COROUTINE is not supported, it leads to stepping into a native coroutine instead of expecting stepping over.

The patch should be relative simple: just add a check for CO_COROUTINE along with CO_GENERATOR everywhere.
msg311037 - (view) Author: Andrew Svetlov (asvetlov) * (Python committer) Date: 2018-01-29 00:25
New changeset 46877024423e98d1b872bf308dacacd583327207 by Andrew Svetlov (Pablo Galindo) in branch 'master':
bpo-32650: Add native coroutine support to bdb when stepping over line (GH-5400)
https://github.com/python/cpython/commit/46877024423e98d1b872bf308dacacd583327207
msg311039 - (view) Author: Yury Selivanov (yselivanov) * (Python committer) Date: 2018-01-29 01:31
New changeset c7ab581db216aeeb1c2aa7af2f2198d2b7516383 by Yury Selivanov (Pablo Galindo) in branch 'master':
bpo-32650 Add support for async generators and more test for coroutines in pdb  (#5403)
https://github.com/python/cpython/commit/c7ab581db216aeeb1c2aa7af2f2198d2b7516383
msg311047 - (view) Author: Yury Selivanov (yselivanov) * (Python committer) Date: 2018-01-29 03:43
New changeset 9ee1bf9ab5af8233ed8ec5c53d12a29dc1bd9c9d by Yury Selivanov in branch 'master':
bpo-32650: Add an asyncgen pdb test (#5406)
https://github.com/python/cpython/commit/9ee1bf9ab5af8233ed8ec5c53d12a29dc1bd9c9d
msg311063 - (view) Author: Andrew Svetlov (asvetlov) * (Python committer) Date: 2018-01-29 05:57
New changeset 543ec005a4c83fcc0d14ac1e4c0f1a36bf84640b by Andrew Svetlov (Miss Islington (bot)) in branch '3.6':
bpo-32650: Add native coroutine support to bdb when stepping over line (GH-5400) (#5402)
https://github.com/python/cpython/commit/543ec005a4c83fcc0d14ac1e4c0f1a36bf84640b
msg311073 - (view) Author: Andrew Svetlov (asvetlov) * (Python committer) Date: 2018-01-29 06:51
New changeset 3cfb84c65790f5f9377574f9be0799bdd9d0132c by Andrew Svetlov in branch '3.6':
[3.6] bpo-32650 Add support for async generators and more test for coroutines in pdb  (GH-5403). (#5411)
https://github.com/python/cpython/commit/3cfb84c65790f5f9377574f9be0799bdd9d0132c
msg311088 - (view) Author: Andrew Svetlov (asvetlov) * (Python committer) Date: 2018-01-29 10:41
New changeset d9c743b2d118530ca13a8e29f96f30950866bd56 by Andrew Svetlov (Miss Islington (bot)) in branch '3.6':
bpo-32650: Add an asyncgen pdb test (GH-5406) (#5419)
https://github.com/python/cpython/commit/d9c743b2d118530ca13a8e29f96f30950866bd56
History
Date User Action Args
2018-01-29 14:22:03miss-islingtonsetpull_requests: + pull_request5263
2018-01-29 13:40:17asvetlovsetpull_requests: + pull_request5262
2018-01-29 10:41:36asvetlovsetmessages: + msg311088
2018-01-29 10:14:48miss-islingtonsetpull_requests: + pull_request5254
2018-01-29 06:51:09asvetlovsetmessages: + msg311073
2018-01-29 06:18:54asvetlovsetpull_requests: + pull_request5244
2018-01-29 05:57:09asvetlovsetmessages: + msg311063
2018-01-29 03:44:15yselivanovsetstatus: open -> closed
type: enhancement
resolution: fixed
stage: patch review -> resolved
2018-01-29 03:43:48yselivanovsetmessages: + msg311047
2018-01-29 03:23:45yselivanovsetpull_requests: + pull_request5239
2018-01-29 01:31:03yselivanovsetmessages: + msg311039
2018-01-29 00:34:31pablogsalsetpull_requests: + pull_request5237
2018-01-29 00:31:08miss-islingtonsetpull_requests: + pull_request5236
2018-01-29 00:25:07asvetlovsetmessages: + msg311037
2018-01-28 23:00:02pablogsalsetkeywords: + patch
stage: patch review
pull_requests: + pull_request5234
2018-01-24 15:16:32vstinnersetnosy: + njs
2018-01-24 15:08:43asvetlovcreate